import java.util.* ;

class Markov {


  /****************************/
  /* Construction de la table */  
  /****************************/

  static HashMap<Prefix,String []> build(String [] files, int n) {

    // Lire l'entre, donne une table prefixe -> Liste de n+unime mots
    HashMap<Prefix,WordList> t = new  HashMap<Prefix,WordList> () ;


    for (String name : files) {
      WordReader reader = new WordReader (name) ;

      String w ;
      Prefix pref = new Prefix (n) ;
      while ((w = reader.read()) != null) {
	t.put(pref, new WordList (w,t.get(pref))) ;
	pref = pref.shift(w) ;
      }
      t.put(pref, new WordList (Prefix.end,t.get(pref))) ;
    }

    // Transformer la table, prefixe -> tableau de n+unime mots
    HashMap<Prefix,String []> r = new  HashMap<Prefix,String []> () ;
    for (Map.Entry<Prefix,WordList> e : t.entrySet()) {      
      r.put(e.getKey(),WordList.toArray(e.getValue())) ;
    }
    return r ;
  }

  /************************/
  /* Production du texte  */
  /************************/

  static void chain(HashMap<Prefix,String []> t, int n) {
    Prefix p = new Prefix (n) ;
    Random rand = new Random () ;

    for ( ; ; ) {
      String [] ws = t.get(p) ;
      String w = ws[rand.nextInt(ws.length)] ;
      if (w.equals(Prefix.end)) {
	System.out.println() ;
	return ;
      }
      dump(w) ;
      p = p.shift(w) ;
    }
  }

  /****************************************************************/
  /* Affichage pas trop moche (et conforme au format de l'entre) */
  /****************************************************************/

  private static boolean fst = true ;

  static void dump(String w) {
    if (w.equals(Prefix.par)) {
      System.out.println() ;
      System.out.print(w) ;
      System.out.println() ;
      fst = true ;
    } else {
      if (!fst) System.out.print(" ") ;
      System.out.print(w) ;
      fst = false ;
    }
  }

  public static void main (String [] arg) {
    Args a = new Args (arg) ;
    chain(build(a.files,a.prefixLength),a.prefixLength) ;
  }
}
